;       BOOTSTRAP LOADER
;DISK SYSTEM
;SINGLE OR DOUBLE DENSITY
;SET THE ASSEMBLY TIME TOGGLE  DOUBLE  ACCORDINGLE
;VERSION 4.1
TRUE    EQU     0FFFFH
FALSE   EQU     NOT TRUE
;
DOUBLE  EQU     TRUE
        ORG     00H
;
;
MSIZE   EQU     16
BIAS    EQU     2900H+(MSIZE-16)*1024
CPMB    EQU     000H+BIAS
LOADP   EQU     CPMB-80H        ;LOAD POINT
BCP     EQU     CPMB+1500H      ;BIOS
PORT    EQU     4AH
LAST    EQU     22      ;LAST SECTOR ON TRK1 TO LOAD
SKIP    EQU     1       ;NUMBER OF SECTORS TO SKIP
;
DMAH    EQU     126     ;HIGH ORDER DMA ADDR
DMAL    EQU     125     ;LOW ORDER DMA ADDR
REBOOT  EQU     125     ;REBOOT SYSTEM ON ERROR
INIT0   EQU     ((SKIP+1) SHL 8) OR 0   ;INITIAL TRACK,SECTOR
END0    EQU     (0 SHL 7) OR 27 ;END OF FIRST TRK
INIT1   EQU     (129 SHL 8) OR 1        ;TRACK,SECT ON TRK 1
END1    EQU     (1 SHL 7) OR LAST+1     ;LAST POSITION ON TRK 1
;
T76     EQU     0FBH    ;TOWARD 76
STT     EQU     0FDH    ;STEP TRACK
DOUT    EQU     7FH     ;DISK OUTPUT PORT
DINP    EQU     7FH     ;DISK INPUT PORT
COMMAND3 EQU    7CH
RDS     EQU     0BFH    ;READ SECTOR
ERR     EQU     0F0H    ;ERROR CONDITIONS
IOF     EQU     08H     ;IO FINISH
;
;
        NOP             ;SOME DYNAMIC MEMORIES PROHIBIT USE OF
                        ;THIS BYTE IN THE BOOTSTRAP
;       INITIALIZE TRK/SEC AND DMA ADDRESS
START:
        LXI     D,INIT0
        LXI     H,LOADP-3
;
READL:  ;READ LOOP
        SPHL            ;SET THE STACK POINTER
;       SEND DMA ADDRESS
        MOV     A,H
        CMA
        OUT     DMAH
        MOV     A,L
        CMA
        OUT     DMAL
;
;       SET UP TRACK AND SECTOR
        ;
        MOV     L,E     ;TRACK TO L
        MOV     A,D     ;SECTOR TO A
        ANI     7FH     ;CLEAR HIGH BIT
        MOV     H,A     ;SECTOR TO H
        XTHL            ;SET TRK AND SECTOR
        INX     SP      ;ADJUST STACK POINTER
        POP     B
;       PERFORM THE READ
        MVI     A,RDS
        OUT     DOUT
;
WRD:    IN      DINP
        ANI     ERR
        JZ      NERROR
;
;       ERROR, REBOOT
        IN      125
        HLT
;
;
NERROR: ;NO ERROR SO FAR
        IN      DINP
        ANI     IOF
        JZ      WRD     ;GO BACK AND WAIT
;
;       I/O FINISH,
;       REPLACE DATA BYTES
        PUSH    B       ;REPLACE 1 BYTE
        INX     SP      ;ADJUST STACK POINTER
        PUSH    H       ;REPLACE 2 BYTES
;
;       ADD 128 TO DMA ADDRESS
        LXI     H,128
        DAD     SP
;       INC TRACK/SECTOR
        INR     D
        MOV     A,D
        CPI     END0    ;END OF TRACK 0?
        JNZ     CMP1
;
;       STEP TRACK TO TRACK 1
        MVI     A,T76
        OUT     DOUT
        ANI     STT
        OUT     DOUT
        MVI     A,T76
        OUT     DOUT
;
WST:    ;WAIT FOR STEP AND HEAD SETTLE (18 MSEC)
        MVI     A,18D
WST0:
        MVI     C,0B0H  ;ONE MILLISEAOND TIMING FOR OUR IMSAI
                        ;CAN BE ADJUSTED FOR DIFFERENT MACHINES
WST2:
        DCR     C
        JNZ     WST2
        DCR     A
        JNZ     WST0
;
;               TRACK STEPPED
;
        IF DOUBLE
;NOW CHANGE DENSITY
;TURN ON DENSITY CHANGE BIT
        MVI     A,0F7H
        OUT     COMMAND3
        ENDIF
;
        LXI     D,INIT1
        MOV     A,D
CMP1:   CPI     END1    ;END OF TRACK 1?
        JNZ     READL   ;GO BACK FOR MORE
;
;       END OF LOAD
;
        IF DOUBLE
        LXI     H,PORT
        MVI     M,8
        INX     H
        MVI     M,8
        INX     H       ;POINT TO DENSITY SELECT
        MVI     M,0FH   ;DOUBLE DENSITY
        ENDIF
;
        IF NOT DOUBLE
        LXI     H,PORT
        MVI     M,0
        INX     H
        MVI     M,0
        INX     H
        MVI     M,0
        ENDIF
;
;SET LOC 4 TO CONTAIN ACTIVE DRIVE = 0
        MVI     L,4
        MOV     M,H
        JMP     LOADP   ;GO TO COMMMND PROCESSOR
;
        ORG     7FH
        DB      0CH     ;FOR SOME DYNAMIC MEMORIES
        END